package com.nju.svcdisambiguation.serviceImp;

import com.nju.svcdisambiguation.dataMapper.acm.ACMAuthorDetailMapper;
import com.nju.svcdisambiguation.dataMapper.acm.ACMInstitutionDetailMapper;
import com.nju.svcdisambiguation.dataMapper.ieee.IEEEAuthorDetailMapper;
import com.nju.svcdisambiguation.dataMapper.ieee.IEEEInstitutionDetailMapper;
import com.nju.svcdisambiguation.po.FieldSummaryPO;
import com.nju.svcdisambiguation.service.InstitutionDetailService;
import com.nju.svcdisambiguation.vo.ResponseVO;
import com.nju.svcdisambiguation.vo.detail.author.AuthorDetailVO;
import com.nju.svcdisambiguation.vo.detail.author.AuthorFieldSummaryVO;
import com.nju.svcdisambiguation.vo.detail.institution.InstitutionAuthorStatVO;
import com.nju.svcdisambiguation.vo.detail.institution.InstitutionFieldStatVO;
import com.nju.svcdisambiguation.vo.detail.institution.InstitutionFieldSummaryVO;
import com.nju.svcdisambiguation.vo.detail.institution.InstitutionInfoVO;
import org.springframework.stereotype.Service;

import java.lang.reflect.Array;
import java.util.ArrayList;

@Service
public class InstitutionDetailServiceImp implements InstitutionDetailService {

    private final IEEEInstitutionDetailMapper ieeeInstitutionDetailMapper;
    private final ACMInstitutionDetailMapper acmInstitutionDetailMapper;
    private IEEEAuthorDetailMapper ieeeAuthorDetailMapper;
    private ACMAuthorDetailMapper acmAuthorDetailMapper;


    public InstitutionDetailServiceImp(IEEEInstitutionDetailMapper ieeeInstitutionDetailMapper, ACMInstitutionDetailMapper acmInstitutionDetailMapper) {
        this.ieeeInstitutionDetailMapper = ieeeInstitutionDetailMapper;
        this.acmInstitutionDetailMapper = acmInstitutionDetailMapper;
    }


    @Override
    public ResponseVO getInstitutionInfo(int instituteId, String db) {
        if (db.equals("ACM")) {
            InstitutionInfoVO institutionInfoVO = acmInstitutionDetailMapper.selectInstitutionDetailById(instituteId);
            institutionInfoVO.setSameIns(acmInstitutionDetailMapper.selectSameInsByInstitutionId(instituteId));
            ArrayList<Integer> a1=new ArrayList<Integer>();
            //作者id表
            int temp=0;
            a1=acmInstitutionDetailMapper.selectInstitutionAuthor(acmInstitutionDetailMapper.selectInstitutionName(instituteId));
            institutionInfoVO.setAuthorCount(a1.size());
            for(int i=0;i<a1.size();i++){
                temp=temp+ acmAuthorDetailMapper.selectDocCountByAuthorId(a1.get(i));
            }
            institutionInfoVO.setPaperCount(temp);
            return ResponseVO.buildSuccess(institutionInfoVO);
        }
        InstitutionInfoVO institutionInfoVO = ieeeInstitutionDetailMapper.selectInstitutionDetailById(instituteId);
        institutionInfoVO.setSameIns(ieeeInstitutionDetailMapper.selectSameInsByInstitutionId(instituteId));
        ArrayList<Integer> a2=new ArrayList<Integer>();
        int temp=0;
        a2=ieeeInstitutionDetailMapper.selectInstitutionAuthor(ieeeInstitutionDetailMapper.selectInstitutionName(instituteId));
        institutionInfoVO.setAuthorCount(a2.size());
        for(int i=0;i<a2.size();i++){
            temp=temp+ ieeeAuthorDetailMapper.selectDocCountByAuthorId(a2.get(i));
        }
        institutionInfoVO.setPaperCount(temp);
        return ResponseVO.buildSuccess(institutionInfoVO);
    }

    @Override
    public ResponseVO getInstitutionFieldStat(int instituteId, String db) {
        ArrayList<FieldSummaryPO> fieldSummaryPOS = new ArrayList<>();
        ArrayList<InstitutionFieldSummaryVO> institutionFieldSummaryVOS = new ArrayList<>();
        if (db.equals("ACM")){
            fieldSummaryPOS = acmInstitutionDetailMapper.selectFieldSummaryPOByInstitutionNAME(acmInstitutionDetailMapper.selectInstitutionName(instituteId));
            for (FieldSummaryPO fieldSummaryPO:fieldSummaryPOS){
                InstitutionFieldSummaryVO institutionFieldSummaryVO = new InstitutionFieldSummaryVO(
                        fieldSummaryPO.getFieldId(),
                        fieldSummaryPO.getFieldName(),
                        fieldSummaryPO.getCount(),
                        "ACM"
                );
                institutionFieldSummaryVOS.add(institutionFieldSummaryVO);
            }
            return ResponseVO.buildSuccess(institutionFieldSummaryVOS);
        }
        fieldSummaryPOS = ieeeInstitutionDetailMapper.selectFieldSummaryPOByInstitutionNAME(ieeeInstitutionDetailMapper.selectInstitutionName(instituteId));
        for (FieldSummaryPO fieldSummaryPO:fieldSummaryPOS){
            InstitutionFieldSummaryVO institutionFieldSummaryVO = new InstitutionFieldSummaryVO(
                    fieldSummaryPO.getFieldId(),
                    fieldSummaryPO.getFieldName(),
                    fieldSummaryPO.getCount(),
                    "IEEE"
            );
            institutionFieldSummaryVOS.add(institutionFieldSummaryVO);
        }
        return ResponseVO.buildSuccess(institutionFieldSummaryVOS);

    }

    @Override
    public ResponseVO getInstitutionAuthorStat(int instituteId, String db) {
        if (db.equals("ACM")) {

            ArrayList<InstitutionAuthorStatVO> institutionAuthorStatVOs = new ArrayList<>();
            ArrayList<Integer> a1=new ArrayList<Integer>();
            a1=acmInstitutionDetailMapper.selectInstitutionAuthor(acmInstitutionDetailMapper.selectInstitutionName(instituteId));
            for(int i=0;i<a1.size();i++){
                InstitutionAuthorStatVO institutionAuthorStatVO = new InstitutionAuthorStatVO();
                institutionAuthorStatVO.setDb(db);
                institutionAuthorStatVO.setId(a1.get(i));
                institutionAuthorStatVO.setName(acmInstitutionDetailMapper.selectAuthorName(a1.get(i)));
                ArrayList<Integer> a2=new ArrayList<Integer>();
                int temp=0;
                a2=acmInstitutionDetailMapper.selectInstitutionAuthor(acmInstitutionDetailMapper.selectInstitutionName(instituteId));
                for(int j=0;j<a2.size();j++){
                    temp=temp+ acmAuthorDetailMapper.selectDocCountByAuthorId(a2.get(j));
                }
                institutionAuthorStatVO.setPaperCount(temp);
                institutionAuthorStatVOs.add(institutionAuthorStatVO);
            }


            return ResponseVO.buildSuccess(institutionAuthorStatVOs);
        }
        ArrayList<InstitutionAuthorStatVO> institutionAuthorStatVOs = new ArrayList<>();
        ArrayList<Integer> a1=new ArrayList<Integer>();
        a1=ieeeInstitutionDetailMapper.selectInstitutionAuthor(acmInstitutionDetailMapper.selectInstitutionName(instituteId));
        for(int i=0;i<a1.size();i++){
            InstitutionAuthorStatVO institutionAuthorStatVO = new InstitutionAuthorStatVO();
            institutionAuthorStatVO.setDb(db);
            institutionAuthorStatVO.setId(a1.get(i));
            institutionAuthorStatVO.setName(ieeeInstitutionDetailMapper.selectAuthorName(a1.get(i)));
            ArrayList<Integer> a2=new ArrayList<Integer>();
            int temp=0;
            a2=ieeeInstitutionDetailMapper.selectInstitutionAuthor(ieeeInstitutionDetailMapper.selectInstitutionName(instituteId));
            for(int j=0;j<a2.size();j++){
                temp=temp+ ieeeAuthorDetailMapper.selectDocCountByAuthorId(a2.get(j));
            }
            institutionAuthorStatVO.setPaperCount(temp);
            institutionAuthorStatVOs.add(institutionAuthorStatVO);
        }
        return ResponseVO.buildSuccess(institutionAuthorStatVOs);
    }


    @Override
    public ResponseVO getInstitutionAuthorActivation(int instituteId, String db) {
        return null;
    }


}
